diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
index 53affeb877..5235fb31b8 100644
--- a/src/backend/replication/logical/reorderbuffer.c
+++ b/src/backend/replication/logical/reorderbuffer.c
@@ -1554,7 +1554,10 @@ ReorderBufferCommit(ReorderBuffer *rb, TransactionId xid,
 		if (using_subtxn)
 			BeginInternalSubTransaction("replay");
 		else
+		{
+			SetCurrentStatementStartTimestamp();
 			StartTransactionCommand();
+		}
 
 		rb->begin(rb, txn);
 
